package com.eactive.eai.adapter.controller;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.StringUtils;
// jwhong
import org.json.simple.JSONObject;
import org.slf4j.MDC;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.util.AntPathMatcher;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.eactive.eai.adapter.AdapterGroupVO;
import com.eactive.eai.adapter.AdapterManager;
import com.eactive.eai.adapter.AdapterPropManager;
import com.eactive.eai.adapter.AdapterVO;
import com.eactive.eai.adapter.http.HttpStatusException;
import com.eactive.eai.adapter.http.client.HttpClientAdapterServiceKey;
import com.eactive.eai.adapter.http.dynamic.HttpAdapterServiceKey;
import com.eactive.eai.adapter.http.dynamic.HttpDynamicInAdapterManager;
import com.eactive.eai.adapter.http.dynamic.HttpDynamicInAdapterUri;
import com.eactive.eai.adapter.http.dynamic.filter.HttpAdapterFilter;
import com.eactive.eai.adapter.http.dynamic.filter.HttpAdapterFilterFactory;
import com.eactive.eai.adapter.http.dynamic.filter.JwtAuthException;
import com.eactive.eai.adapter.service.DJErpApiAdapterService;
import com.eactive.eai.common.TransactionContextKeys;
import com.eactive.eai.common.exception.ExceptionUtil;
import com.eactive.eai.common.server.EAIServerManager;
import com.eactive.eai.common.stdmessage.STDMessageManager;
import com.eactive.eai.common.stdmessage.STDMsgInfoAddOnVO;
import com.eactive.eai.common.util.DatetimeUtil;
import com.eactive.eai.common.util.InboundErrorLogger;
import com.eactive.eai.common.util.Logger;
import com.eactive.eai.common.util.MessageUtil;
import com.eactive.eai.common.util.TxFileLogger;
import com.eactive.eai.common.util.UUIDGenerator;
import com.eactive.eai.inbound.error.InboundErrorInfoVO;

@RestController
public class DJErpApiAdapterController implements HttpAdapterServiceKey {
	static Logger logger = Logger.getLogger(Logger.LOGGER_ADAPTER);

	@Autowired
	DJErpApiAdapterService service;

	/**
	 * DJErp OAuth 조기 적용을 위한 Controller
	 * 
	 * @See com.eactive.eai.authserver.config.AuthorizationServerConfig.configure(AuthorizationServerEndpointsConfigurer
	 *      endpoints)
	 */
	@RequestMapping(value = { 
			"/dj/{path:^(?!oauth).*$}",  "/dj/{path:^(?!oauth).*$}/**",
			"/kp/{path:^(?!oauth).*$}",  "/kp/{path:^(?!oauth).*$}/**",
			"/kkb/{path:^(?!oauth).*$}", "/kkb/{path:^(?!oauth).*$}/**",
			"/nf/{path:^(?!oauth).*$}",  "/nf/{path:^(?!oauth).*$}/**",
			"/bsd/{path:^(?!oauth).*$}", "/bsd/{path:^(?!oauth).*$}/**",
			"/tss/{path:^(?!oauth).*$}", "/tss/{path:^(?!oauth).*$}/**",
			"/tsb/{path:^(?!oauth).*$}", "/tsb/{path:^(?!oauth).*$}/**",
			"/shb/{path:^(?!oauth).*$}", "/shb/{path:^(?!oauth).*$}/**",
			})
	public ResponseEntity<String> callApi(HttpServletRequest servletRequest, HttpServletResponse servletResponse)
			throws Exception {
		// /ONLWeb/api/v1/public/getUserInfo.svc
		String apiUri = servletRequest.getRequestURI();
		// /api/v1/public/getUserInfo.svc
		apiUri = StringUtils.removeStart(apiUri, servletRequest.getContextPath());
		apiUri = StringUtils.removeEnd(apiUri, "/");

		HttpDynamicInAdapterUri adptUri = findAdptUri(apiUri, HttpDynamicInAdapterManager.getInstance(), "");
		
		if (logger.isDebug()) {
			logger.debug("ApiAdapterController] service request uri : " + servletRequest.getRequestURI());
		}

		if (adptUri == null) {
			logError(servletRequest);
			String errorMsg = MessageUtil.makeJsonErrorMessage(MessageUtil.ERROR_CODE_SERVICE_NOT_FOUND,
					"can not find Adapter Uri");
			return ResponseEntity.status(HttpStatus.NOT_FOUND).contentType(MediaType.APPLICATION_JSON).body(errorMsg);
		}

		// Received time , jwhong
		long receivedTimeMillis = System.currentTimeMillis(); // 밀리세컨 단위로 보내야함
		String receivedTimeStr = String.valueOf(receivedTimeMillis);

		String adapterGroupName = adptUri.getAdptGrpName();
		String adapterName = adptUri.getAdptName();
		AdapterGroupVO adapterGroupVO = AdapterManager.getInstance().getAdapterGroupVO(adapterGroupName);
		AdapterVO adapterVO = AdapterManager.getInstance().getAdapterVO(adapterGroupName, adapterName);
		if (adapterVO == null) {
			String errorMsg = MessageUtil.makeJsonErrorMessage(MessageUtil.ERROR_CODE_AP_ERROR,
					"Adapter not found error");
			return ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).contentType(MediaType.APPLICATION_JSON)
					.body(errorMsg);
		}

		Properties httpProp = AdapterPropManager.getInstance().getProperties(adapterVO.getPropGroupName());

		String adptMsgType = adapterVO.getAdapterGroupVO().getMessageType();
		String encode = StringUtils.defaultIfBlank(adapterGroupVO.getMessageEncode(), "UTF-8");
		MediaType mediaType = MediaType.valueOf("application/json;charset=" + encode);
		String errorResponseFormat = httpProp.getProperty(ERROR_RESPONSE_FORMAT);

		ResponseEntity<String> responseEntity = null;
		Properties transactionProp = new Properties();
		String uuid = UUIDGenerator.getUUID().toString().replaceAll("-", "");
		transactionProp.setProperty(TransactionContextKeys.TRANSACTION_UUID, uuid);
		MDC.put(Logger.DISCRIMINATOR, transactionProp.getProperty(TransactionContextKeys.TRANSACTION_UUID));
		
		// jwhong, put api received time, eaiSvcCode
		transactionProp.put(INBOUND_REQUESTED_TIME, receivedTimeStr);

		String responseData = "";
		try {
			responseData = service.callApi(servletRequest, servletResponse, httpProp, adapterGroupVO, adapterVO,
					transactionProp);

			servletResponse.addHeader("traceId",
					transactionProp.getProperty(TransactionContextKeys.TRANSACTION_UUID)); // uuid를 response header에
			int httpStatus = servletResponse.getStatus();
			if (httpStatus != 200) {
				responseEntity = ResponseEntity.status(httpStatus).contentType(mediaType).body(responseData);
			} else {
				responseEntity = ResponseEntity.ok().contentType(mediaType).body(responseData);
			}

		} catch (Exception e) {
			logger.error(adapterGroupName + "-" + adapterName + ">>" + e.getMessage(), e);
			
			String errorMsg = null;
			
			if(e instanceof HttpStatusException ) {
				logger.warn("ApiAdapterController] " + adapterGroupName + "-" + adapterName + ">>" + e.getMessage());
				HttpStatusException e1 = (HttpStatusException) e;
				errorMsg = MessageUtil.makeErrorMessageByMessageType(adptMsgType, encode,
						MessageUtil.ERROR_CODE_AP_ERROR, e1.getMessage(), errorResponseFormat);
				responseEntity = ResponseEntity.status(e1.getStatus()).contentType(mediaType).body(errorMsg);
			}
			else if( e instanceof JwtAuthException )
			{
				logger.error(adapterGroupName + "-" + adapterName + ">>" + e.getMessage(), e);
				errorMsg = MessageUtil.makeErrorMessageByMessageType(adptMsgType, encode,
						MessageUtil.ERROR_CODE_AUTH_FAIL, e.getMessage(), errorResponseFormat);
				responseEntity = ResponseEntity.status(HttpStatus.UNAUTHORIZED).contentType(mediaType).body(errorMsg);
			}
			else 
			{
				logger.error(adapterGroupName + "-" + adapterName + ">>" + e.getMessage(), e);
				errorMsg = MessageUtil.makeErrorMessageByMessageType(adptMsgType, encode,
						MessageUtil.ERROR_CODE_AP_ERROR, e.getMessage(), errorResponseFormat);
				responseEntity = ResponseEntity.status(HttpStatus.INTERNAL_SERVER_ERROR).contentType(mediaType)
						.body(errorMsg);
			}
			responseData = errorMsg;
			
		} finally {
			/**
			 * 로깅 인터셉터에 데이터를 전달하기 위한 처리 이미 거래처리가 끝나서 영향도가 없을만한 servletRequest에 Attribute로 전달
			 * 추후 더 좋은방법이 생길경우 개선 요망
			 */
			try {
				TxFileLogger.logTxFile(transactionProp, responseData, "[IN_SEND]");
				MDC.remove(Logger.DISCRIMINATOR);
				
				servletRequest.setAttribute(TransactionContextKeys.TRANSACTION_PROP, transactionProp);

			} catch (Exception e) {
			    logger.warn("http header db logging fail.", e);
			}
		}
		return responseEntity;
	}

	/**
	 * url에서 뒤쪽 /이후를 제거하면서 찾는다.<br>
	 * /api/v1/public/getUserInfo.svc
	 *
	 * @param apiUri
	 * @return
	 */
	private HttpDynamicInAdapterUri findAdptUri(String apiUri, HttpDynamicInAdapterManager manager,
			String adapterGrpName) throws Exception {
		if (StringUtils.isBlank(apiUri)) {
			return null;
		}

		// * manager 출력
		logger.warn("===== adptUriMap 상세 내용 =====");
		for (Map.Entry<String, HttpDynamicInAdapterUri> entry : manager.adptUriMap.entrySet()) {
			HttpDynamicInAdapterUri uriObj = entry.getValue();
			logger.warn("GroupName=" + uriObj.getAdptGrpName() + ", AdapterName=" + uriObj.getAdptName() + ", URI="
					+ uriObj.getUri());
		}
		logger.warn("================================");

		//
		for (int i = 0; i < 10; i++) {
			HttpDynamicInAdapterUri adptUri = manager.getAdptUri(apiUri);
			if (adptUri != null) {
				if (StringUtils.isNotEmpty(adapterGrpName)) {
					if(adptUri.getAdptGrpName().equals(adapterGrpName)) {
						return adptUri;
					}
				} else {
					return adptUri;
				}
			}

			// /api/v1/public
			apiUri = StringUtils.substringBeforeLast(apiUri, "/");
			if (apiUri.length() < 3) { // /api
				return null;
			}
		}

		return null;
	}

	private void logError(HttpServletRequest request) {
		InboundErrorInfoVO errorInfoVO = new InboundErrorInfoVO();

		EAIServerManager eaiServerManager = EAIServerManager.getInstance();
		String serverName = eaiServerManager.getLocalServerName();
		String uuid = null;
		StringBuffer sb = new StringBuffer();

		String instanceid1 = serverName.substring(0, 2);
		String instanceid2 = serverName.substring(serverName.length() - 2, serverName.length());
		String instid = instanceid1 + instanceid2;
		uuid = instid + UUIDGenerator.getUUID();

		String[] msgArgs = new String[1];
		msgArgs[0] = request.getRequestURI();

		String errorCode = "RECEAIIRP010";
		String errorMsg = ExceptionUtil.make(new Exception("cat not find uri"), errorCode, msgArgs);

		errorInfoVO.setEaiSvcSno(uuid); // EAI서비스일련번호
		errorInfoVO.setAdptBwkGrpNm("HTTP_IN_NO_URI"); // 어댑터업무그룹명
		errorInfoVO.setErrCd(errorCode); // 에러코드
		errorInfoVO.setErrTxt(errorMsg); // 에러내용
		errorInfoVO.setErrTm(DatetimeUtil.getCurrentTime(new Date().getTime())); // 에러발생시각
		errorInfoVO.setErrDstcd(" ");
		sb.append("Remote Addr : ").append(request.getRemoteAddr()).append("\n").append("Request URI : ")
				.append(request.getRequestURI());
		errorInfoVO.setBwkDataTxt(sb.toString()); // 업무데이터내용
		errorInfoVO.setEaiSvrInstNm(serverName); // EAI서버인스턴스명

		InboundErrorLogger.error(errorInfoVO);
	}

	private String makeResponseBodyMsg() {

		Map<String, Object> dataMap = new HashMap<>();
		dataMap.put("result", 1);
		Map<String, Object> map = new HashMap<>();

		map.put("code", "200");
		map.put("data", dataMap);
		map.put("message", "정상 처리 되었습니다.");

		JSONObject json = new JSONObject();
		json.putAll(map);

		return json.toJSONString();
	}

	/*
	 * private String makeResponseBodyMsg(String asyncMsgStyle) {
	 * 
	 * Map<String, Object> dataMap = new HashMap<>(); dataMap.put("result", 1);
	 * Map<String, Object> map = new HashMap<>();
	 * 
	 * switch (asyncMsgStyle) { case "TB_SUC": map.put("rspCode", "TB_SUC_000");
	 * map.put("rspMsg", "정상"); map.put("data", dataMap); break; case "ONLYDATA":
	 * map.put("data", dataMap); map.put("success", "true"); break; default:
	 * map.put("code", "200"); map.put("data", dataMap); map.put("message",
	 * "정상 처리 되었습니다."); break; }
	 * 
	 * JSONObject json = new JSONObject(); json.putAll(map);
	 * 
	 * return json.toJSONString(); }
	 */
}